diff --git a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
index 340e8deb7..4a02e4725 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
@@ -1,201 +1,95 @@
 package net.minecraft.core.net.command.commands;
 
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-import java.util.Map.Entry;
-
-import net.minecraft.core.Global;
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.world.LevelListener;
-import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.World;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.PlayerCommandSender;
-import net.minecraft.core.net.command.ServerCommandHandler;
-import net.minecraft.core.world.season.SeasonManager;
-import net.minecraft.core.world.season.SeasonManagerCycle;
-import net.minecraft.core.world.season.Seasons;
-
-public class TimeCommand extends Command {
-
-	public TimeCommand() {
-		super("time");
-	}
-
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		if (args.length == 0)
-			return false;
-
-		World world = null;
-
-		if (sender instanceof PlayerCommandSender) {
-			world = sender.getPlayer().world;
-		}
-		if (handler instanceof ServerCommandHandler) {
-			ServerCommandHandler server = (ServerCommandHandler) handler;
-
-			if (args[0].equalsIgnoreCase("get") && args.length > 1)
-				world = server.minecraftServer.getDimensionWorld(Integer.parseInt(args[1]));
-			if ((args[0].equalsIgnoreCase("set") || args[0].equalsIgnoreCase("add")) && args.length > 2)
-				world = server.minecraftServer.getDimensionWorld(Integer.parseInt(args[2]));
-		}
-		if (world == null) {
-			throw new CommandError("Must be used by a player, or a dimension must be defined.");
-		}
-
-		if (args[0].equalsIgnoreCase("get")) {
-			sender.sendMessage("The time in dimension " + world.dimension.id + " is " + world.getWorldTime());
-			return true;
-		}
-		if (args[0].equalsIgnoreCase("set")) {
-			String timeStr = args[1];
-			long time = parseTime(timeStr, world);
-			if (time < 0) time = 0;
-			world.setWorldTime(time);
-			handler.sendCommandFeedback(sender, "Set the time to " + time + " in dimension " + world.dimension.id);
-
-			for (LevelListener listener : world.listeners)
-			{
-				listener.allChanged(true, true);
-			}
-
-			return true;
-		}
-		if (args[0].equalsIgnoreCase("add")) {
-			String timeStr = args[1];
-			long time = Long.parseLong(timeStr);
-			world.setWorldTime(world.getWorldTime() + time);
-			handler.sendCommandFeedback(sender, "Set the time to " + world.getWorldTime() + " in dimension " + world.dimension.id);
-
-			for (LevelListener listener : world.listeners)
-			{
-				listener.allChanged(true, true);
-			}
-
-			return true;
-		}
-		return false;
-	}
-
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		sender.sendMessage("/time get [dimension]");
-		sender.sendMessage("/time set <time> [dimension]");
-		sender.sendMessage("/time add <time> [dimension]");
-	}
-
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
-
-	public static long parseTime(String timeString, World world) {
-		int daylength = Global.DAY_LENGTH_TICKS;
-		long time = (world.getWorldTime() / daylength) * daylength; //Start of day
-
-		if(isNumber(timeString)) {
-			return Long.parseLong(timeString);
-		}
-
-		// Parse Day
-		if (timeString.startsWith("day")) {
-			timeString = timeString.substring(3);
-			if(isNumber(timeString)) {
-				return Long.parseLong(timeString) * Global.DAY_LENGTH_TICKS;
-			}
-		}
-
-		SeasonManager seasonManager = world.getSeasonManager();
-		if (seasonManager instanceof SeasonManagerCycle)
-		{
-			SeasonManagerCycle cycleManager = (SeasonManagerCycle) seasonManager;
-			//Parse Season
-			Entry<String, Season> seasonEntry = getEntryStartsWithIgnoreCase(seasonStrings, timeString);
-			if(seasonEntry != null) {
-				timeString = timeString.substring(seasonEntry.getKey().length());
-
-				int yearLength = 0;
-				Integer seasonStart = null;
-
-				List<Season> seasons = world.getSeasonManager().getSeasons();
-				for(Season season : seasons) {
-					if(season == seasonEntry.getValue()) seasonStart = yearLength;
-					yearLength += cycleManager.getConfig().getSeasonLength(season) * Global.DAY_LENGTH_TICKS;
-				}
-				if(seasonStart == null) throw new CommandError("Invalid Season "+seasonEntry.getValue().getTranslatedName()+" for dimension "+world.dimension.getTranslatedName());
-
-				time = (time / yearLength) * yearLength; //Start of year
-				time += seasonStart;
-
-				if(isNumber(timeString)) {
-					int i = Integer.parseInt(timeString);
-
-					int seasonDays = cycleManager.getConfig().getSeasonLength(seasonEntry.getValue());
-					if(i >= seasonDays) throw new CommandError("Season "+seasonEntry.getValue().getTranslatedName()+" only has "+seasonDays+" days!");
-
-					time += (long) i * daylength;
-				}
-			}
-		}
-
-		//Parse Daytime
-		Entry<String, Integer> dayTimeEntry = getEntryStartsWithIgnoreCase(dayTimeStrings, timeString);
-		if(dayTimeEntry != null) {
-			timeString = timeString.substring(dayTimeEntry.getKey().length());
-			time += dayTimeEntry.getValue();
-		}
-
-		return time;
-	}
-
-	public static boolean startsWithIgnoreCase(String a, String b) {
-		if (a.length() < b.length())
-			return false;
-		return a.substring(0, b.length()).equalsIgnoreCase(b);
-	}
-
-	public static boolean isNumber(String s) {
-		if(s == null || s.length() < 1) return false;
-		for(int i=0; i < s.length(); i++) {
-			if(!isNumber(s.charAt(i))) return false;
-		} return true;
-	}
-
-	public static boolean isNumber(char c) {
-		return c >= '0' && c <= '9';
-	}
-
-	public static <E> Entry<String, E> getEntryStartsWithIgnoreCase(Map<String, E> map, String str) {
-		for(Entry<String, E> entry : map.entrySet()) {
-			if(startsWithIgnoreCase(str, entry.getKey())) return entry;
-		} return null;
-	}
-
-	public static Map<String, Integer> dayTimeStrings = new HashMap<>();
-
-	static {
-		dayTimeStrings.put("sunrise", 0);
-		dayTimeStrings.put("day", 1000);
-		dayTimeStrings.put("noon", 6000);
-		dayTimeStrings.put("evening", 12000);
-		dayTimeStrings.put("dusk", 12000);
-		dayTimeStrings.put("sunset", 12000);
-		dayTimeStrings.put("night", 15000);
-		dayTimeStrings.put("midnight", 18000);
-	}
-
-	public static Map<String, Season> seasonStrings = new HashMap<>();
-
-	static {
-		seasonStrings.put("spring", Seasons.OVERWORLD_SPRING);
-		seasonStrings.put("summer", Seasons.OVERWORLD_SUMMER);
-		seasonStrings.put("autumn", Seasons.OVERWORLD_FALL);
-		seasonStrings.put("fall", Seasons.OVERWORLD_FALL);
-		seasonStrings.put("winter", Seasons.OVERWORLD_WINTER);
-	}
-
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.TimeArgumentType;
+
+public class TimeCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("time")
+                .requires(CommandSource::hasAdmin)
+                .then(LiteralArgumentBuilder.<CommandSource>literal("query")
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("daytime")
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    source.sendTranslatableMessage("command.commands.time.query", c.getSource().getWorld().getWorldTime() % 24000L);
+
+                                    return Command.SINGLE_SUCCESS;
+                                }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("gametime")
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    source.sendTranslatableMessage("command.commands.time.query", source.getWorld().getWorldTime() % Integer.MAX_VALUE);
+
+                                    return Command.SINGLE_SUCCESS;
+                                }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("day")
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    source.sendTranslatableMessage("command.commands.time.query", source.getWorld().getWorldTime() / 24000L % Integer.MAX_VALUE);
+
+                                    return Command.SINGLE_SUCCESS;
+                                })))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("set")
+                        .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("time", TimeArgumentType.time())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    int time = c.getArgument("time", Integer.class);
+                                    setWorldTime(source, source.getWorld(), time);
+                                    return Command.SINGLE_SUCCESS;
+                                }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("day")
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    setDayTime(source, source.getWorld(), 1000);
+                                    return Command.SINGLE_SUCCESS;
+                                }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("noon")
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    setDayTime(source, source.getWorld(), 6000);
+                                    return Command.SINGLE_SUCCESS;
+                                }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("night")
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    setDayTime(source, source.getWorld(), 13000);
+                                    return Command.SINGLE_SUCCESS;
+                                }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("midnight")
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    setDayTime(source, source.getWorld(), 18000);
+                                    return Command.SINGLE_SUCCESS;
+                                })))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("add")
+                        .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("time", TimeArgumentType.time())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    int time = c.getArgument("time", Integer.class);
+                                    addWorldTime(source, source.getWorld(), time);
+                                    return Command.SINGLE_SUCCESS;
+                                }))));
+    }
+
+    private static void setDayTime(CommandSource source, World world, long time) {
+        setWorldTime(source, world, world.getWorldTime() - (world.getWorldTime() % 24000L) + time);
+    }
+
+    private static void setWorldTime(CommandSource source, World world, long time) {
+        world.setWorldTime(time);
+        for (LevelListener listener : world.listeners) {
+            listener.allChanged(true, true);
+        }
+        source.sendTranslatableMessage("command.commands.time.set", time);
+    }
+
+    private static void addWorldTime(CommandSource source, World world, long time) {
+        setWorldTime(source, world, world.getWorldTime() + time);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java b/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
index 33acbc9fa..863ed6fc4 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
@@ -1,112 +1,53 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.TextFormatting;
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.FloatArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.weather.Weather;
-import net.minecraft.core.world.weather.Weathers;
-
-public class WeatherCommand extends Command{
-
-	public WeatherCommand() {
-		super("weather", "w");
-	}
-
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		if(args.length == 0) {
-			return false;
-		}
-		
-		if(args[0].equals("list")) {
-			StringBuilder weatherString = new StringBuilder();
-			
-			weatherString.append(TextFormatting.LIGHT_GRAY + "Available weathers: " + TextFormatting.WHITE);
-			weatherString.append("clear");
-			
-			for(Weather weather : Weathers.WEATHERS) {
-				if(weather != null) {
-					weatherString.append(", ");
-					weatherString.append(weather.languageKey.substring(8));
-				}
-			}
-			
-			sender.sendMessage(weatherString.toString());
-			
-			return true;
-		}
-		
-		World world = sender.getWorld();
-		if(args[0].equals("next")) {
-			world.weatherManager.skip();
-			handler.sendCommandFeedback(sender, "Skipping to next weather");
-			return true;
-		}
-		
-		int offset = 0;
-		if(args[0].equals("set")) {
-			offset = 1;
-		}
-		
-		String weatherId = args[offset];
-		Weather weather = getWeather(weatherId, world);
-		if(weather == null) {
-			throw new CommandError("Weather \"" + weatherId + "\" doesn't exist!");
-		}
-		
-		Long duration = null;
-		if(args.length > offset + 1) {
-			duration = Long.parseLong(args[offset + 1]) * 20;
-		}
-		
-		Float power = null;
-		if(args.length > offset + 2) {
-			power = Float.parseFloat(args[offset + 2]);
-		}
-
-		if(duration != null && power != null) {
-			world.weatherManager.overrideWeather(weather, duration, power);
-		}else if(duration != null) {
-			world.weatherManager.overrideWeather(weather, duration);
-		}else {
-			world.weatherManager.overrideWeather(weather);
-		}
-		
-		handler.sendCommandFeedback(sender, TextFormatting.LIGHT_GRAY + "Changing weather to " + TextFormatting.WHITE + weather.getLanguageKey().substring(8));
-		
-		return true;
-	}
-
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
-
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		sender.sendMessage("/weather list");
-		sender.sendMessage("/weather next");
-		sender.sendMessage("/weather set <weather> [duration (sec)] [power (0.0-1.0)]");
-		sender.sendMessage("/weather <weather> [duration (sec)] [power (0.0-1.0)]");
-	}
-	
-	public static Weather getWeather(String string, World world) {
-		try {
-			return Weathers.getWeather(Integer.parseInt(string));
-		}catch (NumberFormatException e) {}
-
-		if(string.equalsIgnoreCase("clear")) {
-			Weather weather = world.worldType.getDefaultWeather();
-			if(weather == null) {
-				throw new CommandError("Dimension " + world.dimension.getTranslatedName() + " does not have a default weather!");
-			}
-			return weather;
-		}
-		
-		return Weathers.getWeatherByLanguageKey(string);
-	}
-
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.TimeArgumentType;
+import net.minecraft.core.net.command.arguments.WeatherArgumentType;
+
+public class WeatherCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("weather")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, Weather>argument("weather", WeatherArgumentType.weather())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            World world = source.getWorld();
+                            Weather weather = c.getArgument("weather", Weather.class);
+
+                            world.weatherManager.overrideWeather(weather);
+                            source.sendTranslatableMessage("command.commands.weather.success", weather.getTranslatedName());
+                            return Command.SINGLE_SUCCESS;
+                        })
+                        .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("duration", TimeArgumentType.time())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    World world = source.getWorld();
+                                    Weather weather = c.getArgument("weather", Weather.class);
+
+                                    world.weatherManager.overrideWeather(weather, c.getArgument("duration", Integer.class));
+                                    source.sendTranslatableMessage("command.commands.weather.success", weather.getTranslatedName());
+                                    return Command.SINGLE_SUCCESS;
+                                })
+                                .then(RequiredArgumentBuilder.<CommandSource, Float>argument("power", FloatArgumentType.floatArg())
+                                        .executes(c -> {
+                                            CommandSource source = c.getSource();
+                                            World world = source.getWorld();
+                                            Weather weather = c.getArgument("weather", Weather.class);
+
+                                            world.weatherManager.overrideWeather(weather, c.getArgument("duration", Integer.class), c.getArgument("power", Float.class));
+                                            source.sendTranslatableMessage("command.commands.weather.success", weather.getTranslatedName());
+                                            return Command.SINGLE_SUCCESS;
+                                        })))));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("w")
+                .requires(CommandSource::hasAdmin)
+                .redirect(command));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/exceptions/CommandExceptions.java b/src/main/java/net/minecraft/core/net/command/exceptions/CommandExceptions.java
new file mode 100644
index 000000000..6bd498c07
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/exceptions/CommandExceptions.java
@@ -0,0 +1,73 @@
+package net.minecraft.core.net.command.exceptions;
+
+import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.lang.I18n;
+
+public class CommandExceptions {
+    private static final SimpleCommandExceptionType INCOMPLETE_ARGUMENT = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.exceptions.incomplete"));
+    private static final SimpleCommandExceptionType NOT_IN_WORLD = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.exceptions.not_in_world"));
+    private static final SimpleCommandExceptionType EMPTY_SELECTOR = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.entity.invalid_selector.empty"));
+    private static final SimpleCommandExceptionType INVALID_SELECTOR = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.entity.invalid_selector.generic"));
+    private static final SimpleCommandExceptionType SINGLE_ENTITY_ONLY = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.entity.invalid_selector.single_entity_only"));
+    private static final SimpleCommandExceptionType SINGLE_PLAYER_ONLY = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.entity.invalid_selector.single_player_only"));
+    private static final SimpleCommandExceptionType PLAYER_ONLY = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.entity.invalid_selector.player_only"));
+    private static final SimpleCommandExceptionType SINGLE_PLAYER_WORLD_ONLY = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.exceptions.single_player_world_only"));
+    private static final SimpleCommandExceptionType MULTIPLAYER_WORLD_ONLY = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.exceptions.multiplayer_world_only"));
+    private static final SimpleCommandExceptionType VOLUME_TOO_LARGE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.exceptions.volume_too_large"));
+    private static final SimpleCommandExceptionType EXPECTED_END_OF_METADATA = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKeyAndFormat("command.exceptions.metadata.unterminated"));
+    private static final SimpleCommandExceptionType EXPECTED_END_OF_TAG = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKeyAndFormat("command.exceptions.tag.unterminated"));
+    private static final DynamicCommandExceptionType EXPECTED_TAG_KEY_VALUE = new DynamicCommandExceptionType((value) -> () -> I18n.getInstance().translateKeyAndFormat("command.exceptions.tag.valueless", value));
+
+    public static SimpleCommandExceptionType incomplete() {
+        return INCOMPLETE_ARGUMENT;
+    }
+
+    public static SimpleCommandExceptionType notInWorld() {
+        return NOT_IN_WORLD;
+    }
+
+    public static SimpleCommandExceptionType emptySelector() {
+        return EMPTY_SELECTOR;
+    }
+
+    public static SimpleCommandExceptionType invalidSelector() {
+        return INVALID_SELECTOR;
+    }
+
+    public static SimpleCommandExceptionType singleEntityOnly() {
+        return SINGLE_ENTITY_ONLY;
+    }
+
+    public static SimpleCommandExceptionType singlePlayerOnly() {
+        return SINGLE_PLAYER_ONLY;
+    }
+
+    public static SimpleCommandExceptionType playerOnly() {
+        return PLAYER_ONLY;
+    }
+
+    public static SimpleCommandExceptionType singlePlayerWorldOnly() {
+        return SINGLE_PLAYER_WORLD_ONLY;
+    }
+
+    public static SimpleCommandExceptionType multiplayerWorldOnly() {
+        return MULTIPLAYER_WORLD_ONLY;
+    }
+
+    public static SimpleCommandExceptionType volumeTooLarge() {
+        return VOLUME_TOO_LARGE;
+    }
+
+    public static SimpleCommandExceptionType expectedEndOfTag() {
+        return EXPECTED_END_OF_TAG;
+    }
+
+    public static SimpleCommandExceptionType expectedEndOfMetadata() {
+        return EXPECTED_END_OF_METADATA;
+    }
+
+    public static DynamicCommandExceptionType expectedTagKeyValue() {
+        return EXPECTED_TAG_KEY_VALUE;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/ArgumentParser.java b/src/main/java/net/minecraft/core/net/command/helpers/ArgumentParser.java
new file mode 100644
index 000000000..3ea6759d9
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/ArgumentParser.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.util.NbtHelper;
+
+import java.util.concurrent.CompletableFuture;
+import java.util.function.BiFunction;
+import java.util.function.Consumer;
+
+public abstract class ArgumentParser {
+    protected StringReader reader;
+    protected int startPosition = 0;
+    protected BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> suggestions = CommandHelper.NO_SUGGESTIONS;
+
+    protected ArgumentParser(StringReader reader) {
+        this.reader = reader;
+    }
+
+    public CompletableFuture<Suggestions> fillSuggestions(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        return this.suggestions.apply(suggestionsBuilder.createOffset(this.reader.getCursor()), consumer);
+    }
+
+    protected int parseMetadata() throws CommandSyntaxException {
+        this.suggestions = CommandHelper.NO_SUGGESTIONS;
+        this.reader.skip();
+        this.reader.skipWhitespace();
+        int cursor = this.reader.getCursor();
+        int metadata = this.reader.readInt();
+        if (metadata < 0) {
+            this.reader.setCursor(cursor);
+            throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.integerTooLow().createWithContext(this.reader, metadata, 0);
+        }
+        this.reader.skipWhitespace();
+        this.suggestions = this::suggestCloseMetadata;
+        if (this.reader.canRead() && this.reader.peek() == ']') {
+            this.suggestions = this::suggestOpenTag;
+            this.reader.skip();
+            return metadata;
+        } else {
+            throw CommandExceptions.expectedEndOfMetadata().createWithContext(this.reader);
+        }
+    }
+
+    protected CompoundTag parseCompound() throws CommandSyntaxException {
+        return NbtHelper.parseNbt(this.reader);
+    }
+
+    protected CompletableFuture<Suggestions> suggestOpenMetadataOrTag(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        if (!this.reader.canRead()) {
+            suggestionsBuilder.suggest(String.valueOf('['));
+            suggestionsBuilder.suggest(String.valueOf('{'));
+        }
+        return suggestionsBuilder.buildFuture();
+    }
+
+    protected CompletableFuture<Suggestions> suggestOpenTag(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        if (!this.reader.canRead()) suggestionsBuilder.suggest(String.valueOf('{'));
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestCloseMetadata(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        if (!this.reader.canRead()) suggestionsBuilder.suggest(String.valueOf(']'));
+        return suggestionsBuilder.buildFuture();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java b/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
new file mode 100644
index 000000000..abba3832b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.util.concurrent.CompletableFuture;
+import java.util.function.Consumer;
+
+public class BlockArgumentParser extends ArgumentParser {
+    private static final SimpleCommandExceptionType INVALID_BLOCK = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.block.invalid_block"));
+
+    private Block block;
+    private int metadata = 0;
+    private CompoundTag tag = new CompoundTag();
+
+    public BlockArgumentParser(StringReader reader) {
+        super(reader);
+    }
+
+    private CompletableFuture<Suggestions> suggestBlocks(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        SuggestionsBuilder suggestionsBuilder2 = suggestionsBuilder.createOffset(this.startPosition);
+        consumer.accept(suggestionsBuilder2);
+        return suggestionsBuilder.add(suggestionsBuilder2).buildFuture();
+    }
+
+    public BlockInput parse() throws CommandSyntaxException {
+        this.startPosition = this.reader.getCursor();
+
+        this.suggestions = this::suggestBlocks;
+        this.parseBlock();
+
+        this.suggestions = this::suggestOpenMetadataOrTag;
+        if (this.reader.canRead() && this.reader.peek() == '[') {
+            this.metadata = this.parseMetadata();
+        }
+
+        if (this.reader.canRead() && this.reader.peek() == '{') {
+            this.reader.skip();
+            this.suggestions = CommandHelper.NO_SUGGESTIONS;
+            this.tag = this.parseCompound();
+        }
+
+        return new BlockInput(this.block, this.metadata, this.tag);
+    }
+
+    private void parseBlock() throws CommandSyntaxException {
+        String string = this.reader.readString();
+        boolean isAir = false;
+        for (Block blockInList : Block.blocksList) {
+            if (blockInList == null) continue;
+            if (CommandHelper.matchesKeyString(blockInList.getKey(), string)) {
+                this.block = blockInList;
+            } else if (CommandHelper.matchesKeyString("tile.air", string)) {
+                this.block = null;
+                isAir = true;
+            }
+        }
+        if (this.block == null && !isAir) throw INVALID_BLOCK.createWithContext(this.reader);
+    }
+
+    public CompletableFuture<Suggestions> fillSuggestions(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        return this.suggestions.apply(suggestionsBuilder.createOffset(this.reader.getCursor()), consumer);
+    }
+}
